apiVersion: logging.banzaicloud.io/v1beta1
kind: Flow
metadata:
  name: "{{ config.keycloak.namespace }}"
  namespace: "{{ config.keycloak.namespace }}"
  annotations:
    elastic.lpc.logius.nl/datastream: "{{ datastream_name | default( config.system.cluster_otap + '-' + config.keycloak.namespace) }}{{ config.system.datastream_zone_suffix }}"
spec:
  filters:   
  # multiformat parser json and regexp
  - parser:
      emit_invalid_record_to_error: false 
      key_name: log
      parse:
        patterns:
        - format: json
        - format: regexp
          expression: /(?<message>.*)/
        type: multi_format
      remove_key_name_field: true
      reserve_data: true
      reserve_time: true
  - throttle: #The throttle rate is set to 100 records/sec
      group_bucket_period_s: 60
      group_bucket_limit: 6000
      group_key: kubernetes.container_name
      group_reset_rate_s: -1
  - record_modifier:
      records:
      - k8s_cluster: "{{ config.system.cluster_name }}"
  - record_transformer: 
      remove_keys: $.kubernetes.labels, $.kubernetes.annotations
  match:
    - select: {}
  localOutputRefs:
    - "{{ config.system.cluster_otap }}-{{ config.keycloak.namespace }}"  # same as the name of the datastream 
